/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of State.xs. Do not edit this file, edit State.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "State.xs"
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef USE_ITHREADS

#ifndef WIN32
    #include <pthread.h>
#endif

/* from threasd.xs  */

/* Values for 'state' member (CPAN threads) */
#define PERL_ITHR_JOINABLE      0
#define PERL_ITHR_DETACHED      1
#define PERL_ITHR_JOINED        2
#define PERL_ITHR_FINISHED      4


/* perl core threads <= 5.8.8 */
typedef struct ithread_s {
    struct ithread_s *next;	/* Next thread in the list */
    struct ithread_s *prev;	/* Prev thread in the list */
    PerlInterpreter *interp;	/* The threads interpreter */
    I32 tid;              	/* Threads module's thread id */
    perl_mutex mutex; 		/* Mutex for updating things in this struct */
    I32 count;			/* How many SVs have a reference to us */
    signed char state;		/* Are we detached ? */
    int gimme;			/* Context of create */
    SV* init_function;          /* Code to run */
    SV* params;                 /* Args to pass function */
#ifdef WIN32
	DWORD	thr;            /* OS's idea if thread id */
	HANDLE handle;          /* OS's waitable handle */
#else
  	pthread_t thr;          /* OS's handle for the thread */
#endif
} ithread;


/* From CPAN threads 1.11 >>>> this typedef was removed */

/* From CPAN threads 1.23 */
typedef struct _ithread {
    struct _ithread *next;      /* Next thread in the list */
    struct _ithread *prev;      /* Prev thread in the list */
    PerlInterpreter *interp;    /* The threads interpreter */
    UV tid;                     /* Threads module's thread id */
    perl_mutex mutex;           /* Mutex for updating things in this struct */
    int count;                  /* How many SVs have a reference to us */
    int state;                  /* Detached, joined, finished, etc. */
    int gimme;                  /* Context of create */
    SV *init_function;          /* Code to run */
    SV *params;                 /* Args to pass function */
#ifdef WIN32
    DWORD  thr;                 /* OS's idea if thread id */
    HANDLE handle;              /* OS's waitable handle */
#else
    pthread_t thr;              /* OS's handle for the thread */
#endif
    IV stack_size;
} ithread2;



NV threads_version;   /* current used threads version */
NV perl_version;      /* joined status for 5.8.0 Win32 */

#define state_is_joined(thread)     ithread_state_is_joined(aTHX_ thread)
#define state_is_finished(thread)   ithread_state_is_finished(aTHX_ thread)
#define state__is_detached(thread)  ithread_state_is_detached(aTHX_ thread)
#define state__is_running(thread)   ithread_state_is_running(aTHX_ thread)
#define state__is_joinable(thread)  ithread_state_is_joinable(aTHX_ thread)
#define state__wantarray(thread)    ithread_state_wantarray(aTHX_ thread)
#define state_coderef(thread)       ithread_state_coderef(aTHX_ thread)
#define state_is_not_joined_nor_detached(thread) \
	                                ithread_state_is_not_joined_nor_detached(aTHX_ thread)


#define THREADS_IS_NEW      (threads_version > 1.23)
#define JOIN_HAS_PROBLEM    (perl_version < 5.008001)

#define ITHREAD_OLD         ((ithread*)thread)
#define ITHREAD_NEW         ((ithread2*)thread)

#define ITHREAD_STATE_IS( state )               \
    (THREADS_IS_NEW ?                           \
          ithread2_state_is(aTHX_ sv, state)    \
        : ithread_state_is(aTHX_ sv, state)     \
    )                                           \

#define FIX_580_JOINED(sv)   state_is_joined_fiexd_580 (aTHX_ sv)



void* state_get_current_ithread (pTHX) {
    void*  thread;
    SV*    thr_sv;
    int    count;

    dSP;
    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSVpv("threads", 0)));
    PUTBACK;
    count = call_method("self", G_SCALAR);

    SPAGAIN;

    if (count != 1)
       croak("%s\n","Internal error, couldn't call thread->self");

    thr_sv = POPs;

    if (THREADS_IS_NEW) {
        thread = (void*)(INT2PTR(ithread2*, SvIV(SvRV(thr_sv))));
    }
    else {
        thread = (void*)(INT2PTR(ithread*, SvIV(SvRV(thr_sv))));
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    return thread;
}


void* state_sv_to_ithread(pTHX_ SV *sv) {
    void* thread = !SvROK(sv) ? state_get_current_ithread(aTHX) :
                    THREADS_IS_NEW ?
                           (void*)INT2PTR(ithread2*, SvIV(SvRV(sv)))
                         : (void*)INT2PTR(ithread*, SvIV(SvRV(sv)))
    ;
    return thread;
}


int ithread_state_is (pTHX_ SV* sv, signed char state) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);
    return (ITHREAD_OLD->state & state) ? 1 : 0;
}


int ithread2_state_is (pTHX_ SV* sv, int state) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);
    return (ITHREAD_NEW->state & state) ? 1 : 0;
}


int state_is_joined_fiexd_580 (pTHX_ SV* sv) {
    if( !ITHREAD_STATE_IS( PERL_ITHR_JOINED ) ){
        void*  thread = state_sv_to_ithread(aTHX_ sv);
        return !((ithread*)thread)->interp;
    }
    else {
        return 1;
    }
}


int ithread_state_is_running (pTHX_ SV* sv) {
    return ! ITHREAD_STATE_IS(PERL_ITHR_FINISHED);
}


int ithread_state_is_finished (pTHX_ SV* sv) {
    return ITHREAD_STATE_IS( PERL_ITHR_FINISHED );
}


int ithread_state_is_detached (pTHX_ SV* sv) {
    return ITHREAD_STATE_IS( PERL_ITHR_DETACHED );
}


int ithread_state_is_joined (pTHX_ SV* sv) {
    if (JOIN_HAS_PROBLEM && !THREADS_IS_NEW) {
        return FIX_580_JOINED(sv);
    }
    return ITHREAD_STATE_IS( PERL_ITHR_JOINED );
}


int ithread_state_is_joinable (pTHX_ SV* sv) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);

    if (THREADS_IS_NEW) {
        return ( (ITHREAD_NEW->state & PERL_ITHR_FINISHED)
        			 && !(ITHREAD_NEW->state & (PERL_ITHR_DETACHED|PERL_ITHR_JOINED)) );
    }
    else if (JOIN_HAS_PROBLEM) {
        return ( (ITHREAD_OLD->state & PERL_ITHR_FINISHED)
        			&& !((ITHREAD_OLD->state & PERL_ITHR_DETACHED) || FIX_580_JOINED(sv)) );
    }
    else {
        return ( (ITHREAD_OLD->state & PERL_ITHR_FINISHED)
                     && !(ITHREAD_OLD->state & (PERL_ITHR_DETACHED|PERL_ITHR_JOINED)) );
    }
}


int ithread_state_is_not_joined_nor_detached (pTHX_ SV* sv) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);

    if (THREADS_IS_NEW) {
        return !(ITHREAD_NEW->state & (PERL_ITHR_DETACHED|PERL_ITHR_JOINED));
    }
    else if (JOIN_HAS_PROBLEM) {
        return !((ITHREAD_OLD->state & PERL_ITHR_DETACHED) || FIX_580_JOINED(sv));
    }
    else {
        return !(ITHREAD_OLD->state & (PERL_ITHR_DETACHED|PERL_ITHR_JOINED));
    }
}


SV* ithread_state_wantarray (pTHX_ SV* sv) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);
    int    gimme
              = THREADS_IS_NEW ? ITHREAD_NEW->gimme
                             : ITHREAD_OLD->gimme
    ;

    return   gimme & G_VOID  ? &PL_sv_undef
           : gimme & G_ARRAY ? &PL_sv_yes
           : &PL_sv_no  // but this isn't G_SCALAR?
    ;
}


SV* ithread_state_coderef (pTHX_ SV* sv) {
    void*  thread  = state_sv_to_ithread(aTHX_ sv);
    SV*    coderef = THREADS_IS_NEW
                   ? ITHREAD_NEW->init_function
                   : ITHREAD_OLD->init_function
    ;

    if (coderef && SvREFCNT(coderef)) {
        SvREFCNT_inc(coderef);
        return coderef;
    }
    else {
        return &PL_sv_undef;
    }
}


/* accessors to thread priority */

SV* ithread_state_get_priority (pTHX_ SV* sv) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);
#ifdef WIN32
    HANDLE thr = THREADS_IS_NEW ? ITHREAD_NEW->handle : ITHREAD_OLD->handle;

    if (thr) {
        int priority = GetThreadPriority(thr);
        if (priority == THREAD_PRIORITY_ERROR_RETURN){
            return &PL_sv_undef;
        }
        return newSViv(priority);
    }
    else {
        return &PL_sv_undef;
    }
#else
    struct sched_param param;
    int  policy;
    int  priority;

    pthread_t thr = THREADS_IS_NEW ? ITHREAD_NEW->thr : ITHREAD_OLD->thr;

    if ( pthread_getschedparam(thr, &policy, &param) ){
        return &PL_sv_undef;
    }
    return newSViv(param.sched_priority);
#endif
}


SV* ithread_state_set_priority (pTHX_ SV* sv, int priority) {
    void*  thread = state_sv_to_ithread(aTHX_ sv);
    int    old_p;
#ifdef WIN32
    HANDLE thr = THREADS_IS_NEW ? ITHREAD_NEW->handle : ITHREAD_OLD->handle;

    if (thr) {
        old_p = GetThreadPriority(thr);
        if ( SetThreadPriority(thr, priority) ){
            return newSViv(old_p);
        }
        else {
            return &PL_sv_undef;
        }
    }
    else {
        return &PL_sv_undef;
    }
#else
    struct sched_param param;
    int  policy;

    pthread_t thr = THREADS_IS_NEW ? ITHREAD_NEW->thr : ITHREAD_OLD->thr;

    if ( pthread_getschedparam(thr, &policy, &param) ) {
        return &PL_sv_undef;
    }

    old_p = param.sched_priority;

    param.sched_priority = priority;

    if (pthread_setschedparam(thr, policy, &param)) {
        return &PL_sv_undef;
    }
    return newSViv(old_p);
#endif
}


#endif /* USE_ITHREADS */



#line 340 "State.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 484 "State.c"
#ifdef USE_ITHREADS
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_threads__is_running); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads__is_running)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = state__is_running(obj);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads_is_finished); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads_is_finished)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = state_is_finished(obj);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads__is_detached); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads__is_detached)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = state__is_detached(obj);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads_is_joined); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads_is_joined)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = state_is_joined(obj);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads__is_joinable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads__is_joinable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = state__is_joinable(obj);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads_is_not_joined_nor_detached); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads_is_not_joined_nor_detached)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = state_is_not_joined_nor_detached(obj);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads__wantarray); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads__wantarray)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	SV *	RETVAL;

	RETVAL = state__wantarray(obj);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads_coderef); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads_coderef)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SV*	obj = ST(0)
;
	SV *	RETVAL;

	RETVAL = state_coderef(obj);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_threads_priority); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_threads_priority)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "obj, ...");
    {
	SV*	obj = ST(0)
;
#line 372 "State.xs"
    int priority;
    SV* ret;
#line 653 "State.c"
	SV *	RETVAL;
#line 375 "State.xs"
    if (items > 1) {
        priority = SvIV(ST(1));
        ret      = ithread_state_set_priority(aTHX_ obj, priority);
    }
    else {
        ret = ithread_state_get_priority(aTHX_ obj);
    }
    RETVAL = ret;
#line 664 "State.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif /* USE_ITHREADS */
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Thread__State); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Thread__State)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

#if XSubPPtmpAAAA
        newXS_deffile("threads::_is_running", XS_threads__is_running);
        newXS_deffile("threads::is_finished", XS_threads_is_finished);
        newXS_deffile("threads::_is_detached", XS_threads__is_detached);
        newXS_deffile("threads::is_joined", XS_threads_is_joined);
        newXS_deffile("threads::_is_joinable", XS_threads__is_joinable);
        newXS_deffile("threads::is_not_joined_nor_detached", XS_threads_is_not_joined_nor_detached);
        newXS_deffile("threads::_wantarray", XS_threads__wantarray);
        newXS_deffile("threads::coderef", XS_threads_coderef);
        newXS_deffile("threads::priority", XS_threads_priority);
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 390 "State.xs"
{
#ifdef USE_ITHREADS
    /* check threads VERSION for CPAN version */

    HV*  stash;
    HV*  mains;
    SV** svp;

    stash = gv_stashpv("threads", 0);
    mains = gv_stashpv("main", 0);

    svp   = hv_fetch(mains, "]", 1, 0);
    if ( svp && SvNOK(GvSV(*svp)) ){
        perl_version = SvNV(GvSV(*svp));
    }

    if (stash) {
        svp = hv_fetch(stash, "VERSION", 7, 0);
        if ( svp && SvOK(GvSV(*svp)) ){
            threads_version = SvNV(GvSV(*svp));
        }
    }

    if (!threads_version) {
        croak("You must use threads before using Thread::State.");
    }
    else if (threads_version > 1.07 && threads_version < 1.23) {
        croak("Thread::State requires CORE threads or CPAN threads version >= 1.23.");
    }
#endif /* USE_ITHREADS */
}

#line 749 "State.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

